/*
 * Copyright (c) 2012-2016, The Linux Foundation. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 and
 * only version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef __SIRF_TIMER_H
#define __SIRF_TIMER_H

#if defined(CONFIG_ARCH_MARCO) || defined(CONFIG_ARCH_ATLAS7)
#ifdef CONFIG_ARCH_MARCO
#define OST_MODULE_BASE				0xCC020000
#else
#define OST_MODULE_BASE				0x10DC0000
#define OSTB_MODULE_BASE			0x10DC8000
#define TIMERB_32COUNTER_0_CTRL			(OSTB_MODULE_BASE + 0x0000)
#define TIMERB_32COUNTER_1_CTRL			(OSTB_MODULE_BASE + 0x0004)
#define TIMERB_32COUNTER_2_CTRL			(OSTB_MODULE_BASE + 0x0008)
#define TIMERB_32COUNTER_3_CTRL			(OSTB_MODULE_BASE + 0x000c)
#define TIMERB_32COUNTER_4_CTRL			(OSTB_MODULE_BASE + 0x0010)
#define TIMERB_32COUNTER_5_CTRL			(OSTB_MODULE_BASE + 0x0014)
#define TIMERB_MATCH_0				(OSTB_MODULE_BASE + 0x0018)
#define TIMERB_MATCH_1				(OSTB_MODULE_BASE + 0x001c)
#define TIMERB_MATCH_2				(OSTB_MODULE_BASE + 0x0020)
#define TIMERB_MATCH_3				(OSTB_MODULE_BASE + 0x0024)
#define TIMERB_MATCH_4				(OSTB_MODULE_BASE + 0x0028)
#define TIMERB_MATCH_5				(OSTB_MODULE_BASE + 0x002c)
#define TIMERB_32COUNTER_0_MATCH_NUM		(OSTB_MODULE_BASE + 0x0030)
#define TIMERB_32COUNTER_1_MATCH_NUM		(OSTB_MODULE_BASE + 0x0034)
#define TIMERB_32COUNTER_2_MATCH_NUM		(OSTB_MODULE_BASE + 0x0038)
#define TIMERB_32COUNTER_3_MATCH_NUM		(OSTB_MODULE_BASE + 0x003c)
#define TIMERB_32COUNTER_4_MATCH_NUM		(OSTB_MODULE_BASE + 0x0040)
#define TIMERB_32COUNTER_5_MATCH_NUM		(OSTB_MODULE_BASE + 0x0044)
#define TIMERB_COUNTER_0			(OSTB_MODULE_BASE + 0x0048)
#define TIMERB_COUNTER_1			(OSTB_MODULE_BASE + 0x004c)
#define TIMERB_COUNTER_2			(OSTB_MODULE_BASE + 0x0050)
#define TIMERB_COUNTER_3			(OSTB_MODULE_BASE + 0x0054)
#define TIMERB_COUNTER_4			(OSTB_MODULE_BASE + 0x0058)
#define TIMERB_COUNTER_5			(OSTB_MODULE_BASE + 0x005c)
#define TIMERB_INTR_STATUS			(OSTB_MODULE_BASE + 0x0060)
#define TIMERB_WATCHDOG_EN			(OSTB_MODULE_BASE + 0x0064)
#define TIMERB_64COUNTER_CTRL			(OSTB_MODULE_BASE + 0x0068)
#define TIMERB_64COUNTER_LO			(OSTB_MODULE_BASE + 0x006c)
#define TIMERB_64COUNTER_HI			(OSTB_MODULE_BASE + 0x0070)
#define TIMERB_64COUNTER_LOAD_LO		(OSTB_MODULE_BASE + 0x0074)
#define TIMERB_64COUNTER_LOAD_HI		(OSTB_MODULE_BASE + 0x0078)
#define TIMERB_64COUNTER_RLATCHED_LO		(OSTB_MODULE_BASE + 0x007c)
#define TIMERB_64COUNTER_RLATCHED_HI		(OSTB_MODULE_BASE + 0x0080)
#endif
#define TIMER_32COUNTER_0_CTRL			(OST_MODULE_BASE + 0x0000)
#define TIMER_32COUNTER_1_CTRL			(OST_MODULE_BASE + 0x0004)
#define TIMER_32COUNTER_2_CTRL			(OST_MODULE_BASE + 0x0008)
#define TIMER_32COUNTER_3_CTRL			(OST_MODULE_BASE + 0x000c)
#define TIMER_32COUNTER_4_CTRL			(OST_MODULE_BASE + 0x0010)
#define TIMER_32COUNTER_5_CTRL			(OST_MODULE_BASE + 0x0014)
#define TIMER_MATCH_0				(OST_MODULE_BASE + 0x0018)
#define TIMER_MATCH_1				(OST_MODULE_BASE + 0x001c)
#define TIMER_MATCH_2				(OST_MODULE_BASE + 0x0020)
#define TIMER_MATCH_3				(OST_MODULE_BASE + 0x0024)
#define TIMER_MATCH_4				(OST_MODULE_BASE + 0x0028)
#define TIMER_MATCH_5				(OST_MODULE_BASE + 0x002c)
#define TIMER_32COUNTER_0_MATCH_NUM		(OST_MODULE_BASE + 0x0030)
#define TIMER_32COUNTER_1_MATCH_NUM		(OST_MODULE_BASE + 0x0034)
#define TIMER_32COUNTER_2_MATCH_NUM		(OST_MODULE_BASE + 0x0038)
#define TIMER_32COUNTER_3_MATCH_NUM		(OST_MODULE_BASE + 0x003c)
#define TIMER_32COUNTER_4_MATCH_NUM		(OST_MODULE_BASE + 0x0040)
#define TIMER_32COUNTER_5_MATCH_NUM		(OST_MODULE_BASE + 0x0044)
#define TIMER_COUNTER_0				(OST_MODULE_BASE + 0x0048)
#define TIMER_COUNTER_1				(OST_MODULE_BASE + 0x004c)
#define TIMER_COUNTER_2				(OST_MODULE_BASE + 0x0050)
#define TIMER_COUNTER_3				(OST_MODULE_BASE + 0x0054)
#define TIMER_COUNTER_4				(OST_MODULE_BASE + 0x0058)
#define TIMER_COUNTER_5				(OST_MODULE_BASE + 0x005c)
#define TIMER_INTR_STATUS			(OST_MODULE_BASE + 0x0060)
#define TIMER_WATCHDOG_EN			(OST_MODULE_BASE + 0x0064)
#define TIMER_64COUNTER_CTRL			(OST_MODULE_BASE + 0x0068)
#define TIMER_64COUNTER_LO			(OST_MODULE_BASE + 0x006c)
#define TIMER_64COUNTER_HI			(OST_MODULE_BASE + 0x0070)
#define TIMER_64COUNTER_LOAD_LO			(OST_MODULE_BASE + 0x0074)
#define TIMER_64COUNTER_LOAD_HI			(OST_MODULE_BASE + 0x0078)
#define TIMER_64COUNTER_RLATCHED_LO		(OST_MODULE_BASE + 0x007c)
#define TIMER_64COUNTER_RLATCHED_HI		(OST_MODULE_BASE + 0x0080)
#define ATLAS7_WATCHDOG_CTRL		TIMER_32COUNTER_5_CTRL
#define ATLAS7_WATCHDOG_MATCH		TIMER_MATCH_5
#define ATLAS7_WATCHDOG_COUNTER		TIMER_COUNTER_5
#define IMER_COUNTER_WD				(OST_MODULE_BASE + 0x0084)
#define TIMER_32COUNTER_WD_CTRL		(OST_MODULE_BASE + 0x008C)
#define TIMER_MATCH_WD				(OST_MODULE_BASE + 0x0090)

#define A7DA_WDOG_EN_BIT    1
#define A7DA_WDT_EN_BIT     1
#else
#define OST_MODULE_BASE				0xb0020000
#define TIMER_COUNTER_LO			(OST_MODULE_BASE + 0x0000)
#define TIMER_COUNTER_HI			(OST_MODULE_BASE + 0x0004)
#define TIMER_MATCH_0				(OST_MODULE_BASE + 0x0008)
#define TIMER_MATCH_1				(OST_MODULE_BASE + 0x000c)
#define TIMER_MATCH_2				(OST_MODULE_BASE + 0x0010)
#define TIMER_MATCH_3				(OST_MODULE_BASE + 0x0014)
#define TIMER_MATCH_4				(OST_MODULE_BASE + 0x0018)
#define TIMER_MATCH_5				(OST_MODULE_BASE + 0x001c)
#define TIMER_STATUS				(OST_MODULE_BASE + 0x0020)
#define TIMER_INT_EN				(OST_MODULE_BASE + 0x0024)
#define TIMER_WATCHDOG_EN			(OST_MODULE_BASE + 0x0028)
#define TIMER_DIV				(OST_MODULE_BASE + 0x002c)
#define TIMER_LATCH				(OST_MODULE_BASE + 0x0030)
#define TIMER_LATCHED_LO			(OST_MODULE_BASE + 0x0034)
#define TIMER_LATCHED_HI			(OST_MODULE_BASE + 0x0038)
#endif

#define SIRFSOC_TIMER_WDT_INDEX			5

#endif
